// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test the cal rawx2mm calls
//
#include <fstream>
#include <iostream>
#include <iomanip>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

using namespace std;

int main()
{
	calServer.setInstrument(Xmm::EPN);
	calServer.state()->ccd()->set(4);
	calServer.state()->randomize()->set(false);
	calServer.state()->temperature()->set(293.);
	calServer.state()->temperatureCamera()->set(293.);

	double xmm[] = { 0. },
		   ymm[] = { 0. },
		   zmm[] = { 0. };
	CalReal64Vector x(xmm, 1), y(ymm, 1), z(zmm, 1);
	GeometryDataServer *cdf = 0; cdf = calServer.getAtom(cdf);
	XmmCartesianPointList pl = cdf->camCoord2List(x, y, z);
	XmmPixelList pix = pl.toCamCoord1().toChipCoord();
	cout<<pix.x()[0]<<" "<<pix.y()[0]<<endl;

	return 0;
}
