// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	calviewdummy: simple calview front-end to test the backend
//

#include <iostream>
#include <sstream>
#include "../calview/CalView.h"

using namespace std;

int main()
{
	CalViewState *state = calViewServer.state();
	state->E.set(12000.);
	cout<<"E is set to: "<<state->E.get()<<endl;

	for (unsigned n=0; n<calViewServer.viewables(); ++n) {
		const CalViewable *v = calViewServer.viewable()[n];
		cout<<"Viewable object: "<<v->name()<<" - "<<v->whatIs()<<endl;
		stringstream s;
		s<<v->name()<<".set";
		v->view(s.str());
		for (unsigned m=0; m<v->subViewables(); ++m) {
			const CalViewable *sv = v->subViewable()[n];
			cout<<"   sub viewable object: "<<sv->name()<<" - "<<v->whatIs()
				<<endl;
		}
	}

	return 0;
}
